' FileName: FTN2Txt.Bas
' Date: 6/26/2016
' Author: Ben Ritchey
' Description: FIDONet .MSG body extracted to Plain Text


#COMPILER PBCC 5
#COMPILE EXE
#DIM ALL

FUNCTION PBMAIN () AS LONG

local INFile, OUTFile as string
local A as string
local L, B, FSize as long
local C as integer

Startup:
print "FTN2Txt v1.B  {c} 2016  Ben Ritchey"
INFile=command$
if not isfile(INFile) then goto Finished

' convert FSpec to Upper case
for L = 1 to len(INFile)
  A=mid$(INFile,L,1)
  If asc(A)>96 and asc(A)<123 then
    A=chr$(asc(A)-32)
    mid$(INFile,L,1)=A
  end if
next L

B=instr(INFile,".MSG")
If B<2 then goto Finished
A=mid$(INFile,1,B-1)
OUTFile=A+".TXT"
if isfile(OUTFile) then kill OUTFile

open INFile for binary as #1 len=1
FSize=lof(1)
if FSize<191 then goto Finished

seek #1, 191  ' Text area
open OUTFile for binary as #2 len=1
print "  Converting ";INFile;" to ";OUTFile

NextIN:

get$ #1,1,A: if A=chr$(10) or A=chr$(141) then goto NextIN
if A<>chr$(1) then goto Copy1st

' skip kludge
while not eof(1) and A<>chr$(13)
  get$ #1,1,A
wend

' Premature eof
if eof(1) then goto Finished

goto NextIN

' Copy remainder of body
Copyit:
  if eof(1) then goto Finished
  get$ #1,1,A: if A=chr$(10) or A=chr$(141) then goto Copyit

Copy1st:
  if A=chr$(0) or A=chr$(1) then goto Finished
  put$ #2,A
' convert to DOS speak
  if A=chr$(13) then put$ #2,chr$(10)
goto Copyit

Finished:

close

ENDITALL:
END FUNCTION

